pro molbase_read,mol

; initializes molecule structure mol from Leiden Molecular Database
;
;

  path = '/home/Star1/fheitsch/leidenmolbase/'

;==================================================================

  kboltz = 1.381d-16
  hplanck= 6.626d-27

  totlev = 0
  ntemp  = 0
  idum1  = 0
  idum2  = 0
  idum3  = 0
  rdum1  = 0.0
  rdum2  = 0.0
  rdum3  = 0.0
  sdum1  = "huhu"

; get the molecule name from molecular transition identifier in mol
  sp     = strpos(mol.fillab,"-")
;  print,mol.fillab,sp
  molstr = strmid((mol.fillab),0,sp)
  print,"MOLBASE_READ: reading molecule ",molstr
  
  fnm = path+'mol_'+molstr+'.dat' 
  openr,dun,fnm,/get_lun
  readf,dun,format='(/)'
;  readf,dun,format='(/)'
  readf,dun,format='(11x,i3)',sdum1,totlevel
  print,format='("MOLBASE_READ: total levels = ",i3)',totlevel
  if (totlevel lt mol.nlev) then begin
    print,format,'("MOLBASE_READ: nlev higher than totlevel")'
    stop
  endif
  readf,dun,format='(11x,i3)',ntemp
  print,format='("MOLBASE_READ: temperatures = ",i3)',ntemp
  readf,dun,format='(/)'
  readf,dun,format='(/)'
  readf,dun,format='(/)'
  readf,dun,format='(/)'
  for n=1,mol.nlev-1 do begin
    readf,dun,format='(i5,i6,i6,e12.3,f16.7,f10.2)',idum1,idum2,idum3,rdum1,rdum2,rdum3
    (*(mol.peinst))[n]   = rdum1
    (*(mol.pfreq)) [n]   = rdum2*1e9 ; in Hz now
    (*(mol.pener)) [n]   = rdum3*kboltz/hplanck ; in Hz
  endfor
  for n=mol.nlev+1,totlevel-1 do begin
    readf,dun,format='(/)'
  endfor
  for n=0,ntemp-1 do begin
    readf,dun,format='(/)'
  endfor
  for j=1,mol.nlev-1 do begin
    for i=0,j-1 do begin
      readf,dun,format='(i5,i6,i6,e9.1,e8.1)',idum1,idum2,idum3,rdum1,rdum2
      (*(mol.pcoll))[i,j] = rdum2
;      print,i,j,rdum2
    endfor
  endfor
  (*(mol.pcoll)) = transpose((*(mol.pcoll)))

  free_lun,dun

;==================================================================

  return
end
